#!/bin/sh

if [ $# -ne 3 ]; then
    echo "usage: $0 <hdfs-dir> <context-uri> <sparql-url>" >&2
    exit 1
fi

FILES="$1/*/*.nt"
CTX=$2
SPARQL=$3

# 0. sanity check - are there any files there
hadoop fs -test -e "$FILES" || exit 1

# 1. push to a new context
hadoop fs -cat "$FILES" | curl -H 'Content-Type: text/turtle' --data-binary @- "$SPARQL?context-uri=$CTX"

# 2. delete all other contexts
curl -X POST "$SPARQL" --data-urlencode 'update=DELETE { GRAPH ?g { ?s ?p ?o } } WHERE { GRAPH ?g { ?s ?p ?o } . FILTER(?g != <'"$CTX"'>) }'
